BEGIN	{
	firstIOC = "yes"
	firstheader = "yes"
	corbastring = ""
}
/^XSD/	{
	next
}
/^File/	{
	filename = $2
	s = length(filename)
	modulename = substr(filename, 1, s-4)
	topfilename = modulename "_idl"
	topfilename = "_" topfilename "_"
	print "" >filename
	print "// File: " modulename ".idl" >filename
	print "#ifndef " topfilename >filename
	print "#define " topfilename >filename
	next
}
/^Header/ {
	if (firstheader == "yes")
	{
		print "" >filename
	}
	firstheader = "no"
	print "#include <" $2 ">" >filename
	next
}
/^Title/	{
	title = substr($0,7)
	print "" >filename
	print "#pragma prefix \"3gpp.org\"" >filename
	print "" >filename
	print "/**" >filename
	printstring=""
	therest=""
	printline("This CORBA IDL module defines constants for each " title " IOC class name and the attribute names for each defined IOC class. It also defines typedef constants for each " title " attribute for each defined IOC class.")
	print " * " printstring >filename
	tempstring = therest
	printline(tempstring)
	print " * " printstring >filename
	if (therest != "")
	{
		
		tempstring = therest
		printline(tempstring)
		print " * " printstring >filename
		if (therest != "")
		{
			tempstring = therest
			printline(tempstring)
			print " * " printstring >filename
			if (therest != "")
			{
				tempstring = therest
				printline(tempstring)
				print " * " printstring >filename
				if (therest != "")
				{
					print " * " therest >filename
				}
			}
		}
	}
	print " */" >filename
	print "" >filename
	print "module " modulename >filename
	print "{" >filename
	next
}
/^IOC/ {
	classname = $2
	inheritedclass = $3
	if (inheritedclass == "-")
	{
		inheritedclass = ""
	}
	inheriteduserlabel = "YES"
	if (inheritedclass == "PP2GenericNRMIRPConstDefs::Top")
	{
		inheriteduserlabel = "NO"
	}
	if (firstIOC != "yes")
	{
		print "    };" >filename
		if (corbastring != "")
		{
			print corbastring >filename
		}
		print "" >filename
		corbastring = ""
	}
	else
	{
		if (corbastring != "")
		{
			print corbastring >filename
			corbastring = ""
		}
	}
	firstIOC = "no"
	print "    /**" >filename
	print "     *  Definitions for MO class " classname >filename
	print "     */" >filename
	print "" >filename
	if (inheritedclass == "")
	{
		print "    interface " classname >filename
	}
	else
	{
		c = "    interface " classname " : " inheritedclass
		if (length(c) > 65)
		{
			print "    interface " classname >filename
			print "        : " inheritedclass >filename
		}
		else
		{
			print "    interface " classname " : " inheritedclass >filename
		}
	}
	print "    {" >filename
	print "        const string CLASS = \"" classname "\";" >filename
	print "" >filename
	print "        // Attribute Names" >filename
	print "        //" >filename
	next
}
/^Background/	{
	if (($2 == "typedef") && ($3 == "string") && ($4 == "UserLabelType;"))
	{
		arr["userLabel"] = "userLabel"
	}
	if ($2 == "-")
	{
		string = "    "
	}
	else
	{
		string = $2
	}
	if ($2 != "")
	{
		if ($3 != "")
		{
			if ($3 == "-")
			{
				str = "    "
			}
			else
			{
				str = $3
			}
			string = string " " str
			if ($4 != "")
			{
				string = string " " $4
				if ($5 != "")
				{
					string = string " " $5
					if ($6 != "")
					{
						string = string " " $6
						if ($7 != "")
						{
							string = string " " $7
							if ($8 != "")
							{
								string = string " " $8
								if ($9 != "")
								{
									string = string " " $9
									if ($10 != "")
									{
										string = string " " $10
									}
								}
							}
						}
					}
				}
			}
		}
		corbastring = corbastring "\n" "    " string
	}
	else
	{
		corbastring = corbastring "\n"
	}
	next
}
/^userLabel/	{
	if (inheriteduserlabel == "NO")
	{
		if (s <= 20)
		{
			print "        const string " $1 " = \"" $1 "\";" >filename
		}
		else
		{
			print "        const string " $1 " = " >filename
			print "            \"" $1 "\";" >filename
		}
	}
	if ($1 in arr)
	{
		corbastring = corbastring "\n" "        // " $1
		next
	}
	arr[$1] = $1
	string = $1
	string = uppercase(substr(string,1,1)) substr(string,2)
	typedef = $2
	if (typedef != "-")
	{
		if ($3 != "")
		{
			typedef = typedef " " $3
			if ($4 != "")
			{
				typedef = typedef " " $4
			}
		}
		string = "typedef " typedef " " string ";"
		printstring=""
		therest=""
		printline(string)
		corbastring = corbastring "\n" "    " printstring
		if (therest != "")
		{
			corbastring = corbastring "\n" "        " therest
		}
	}
	next
}
/^Link /	{
	if ($2 in arr)
	{
		corbastring = corbastring "\n" "        // " $2
		next
	}
	arr[$2] = $2
	string = $2
	string = uppercase(substr(string,1,1)) substr(string,2)
	typedef = $3
	if (typedef != "-")
	{
		if ($4 != "")
		{
			typedef = typedef " " $4
			if ($5 != "")
			{
				typedef = typedef " " $5
			}
		}
		string = "typedef " typedef " " string ";"
		printstring=""
		therest=""
		printline(string)
		corbastring = corbastring "\n" "    " printstring
		if (therest != "")
		{
			corbastring = corbastring "\n" "        " therest
		}
	}
	next
}
/^EE /	{
	if ($2 in arr)
	{
		corbastring = corbastring "\n" "        // " $2
		next
	}
	arr[$2] = $2
	string = $2
	string = uppercase(substr(string,1,1)) substr(string,2)
	typedef = $3
	if (typedef != "-")
	{
		if ($4 != "")
		{
			typedef = typedef " " $4
			if ($5 != "")
			{
				typedef = typedef " " $5
			}
		}
		string = "typedef " typedef " " string ";"
		printstring=""
		therest=""
		printline(string)
		corbastring = corbastring "\n" "    " printstring
		if (therest != "")
		{
			corbastring = corbastring "\n" "        " therest
		}
	}
	next
}
//	{
	s = length($1)
	if (s <= 20)
	{
		print "        const string " $1 " = \"" $1 "\";" >filename
	}
	else
	{
		print "        const string " $1 " = " >filename
		print "            \"" $1 "\";" >filename
	}
	if ($1 in arr)
	{
		corbastring = corbastring "\n" "        // " $1
		next
	}
	arr[$1] = $1
	string = $1
	string = uppercase(substr(string,1,1)) substr(string,2)
	typedef = $2
	if (typedef != "-")
	{
		if ($3 != "")
		{
			typedef = typedef " " $3
			if ($4 != "")
			{
				typedef = typedef " " $4
			}
		}
		string = "typedef " typedef " " string ";"
		printstring=""
		therest=""
		printline(string)
		corbastring = corbastring "\n" "    " printstring
		if (therest != "")
		{
			tempstring = therest
			printline(tempstring)
			corbastring = corbastring "\n" "        " printstring
			if (therest != "")
			{
				corbastring = corbastring "\n" "        " therest
			}
		}
	}
	next
}
END	{
	print "    };" >filename
	if (corbastring != "")
	{
		print corbastring >filename
	}
	print "" >filename
	print "}; // End of module " modulename >filename
	print "" >filename
	print "#endif //" topfilename >filename
}
function printline(string)
{
	therest = ""
	if (length(string) <= 60)
	{
		printstring = string
		return
	}
	num = split(string, a, " ")
	newstring = a[1]
	for (i = 2; i <= num; i++)
	{
		if (length(newstring) + 1 + length(a[i]) <= 60)
		{
			newstring = newstring " " a[i]
		}
		else
		{
			break
		}
	}
	printstring = newstring
	therest = a[i]
	for (i = i + 1; i <= num; i++)
	{
		therest = therest " " a[i]
	}
	return
}
function uppercase(a)
{
	if (a == "a") return "A"
	if (a == "b") return "B"
	if (a == "c") return "C"
	if (a == "d") return "D"
	if (a == "e") return "E"
	if (a == "f") return "F"
	if (a == "g") return "G"
	if (a == "h") return "H"
	if (a == "i") return "I"
	if (a == "j") return "J"
	if (a == "k") return "K"
	if (a == "l") return "L"
	if (a == "m") return "M"
	if (a == "n") return "N"
	if (a == "o") return "O"
	if (a == "p") return "P"
	if (a == "q") return "Q"
	if (a == "r") return "R"
	if (a == "s") return "S"
	if (a == "t") return "T"
	if (a == "u") return "U"
	if (a == "v") return "V"
	if (a == "w") return "W"
	if (a == "x") return "X"
	if (a == "y") return "Y"
	if (a == "z") return "Z"
	return a
}