BEGIN	{
	firstbackground = "YES"
	numnamespace = 0
	endstring = ""
}
/^File/	{
	next
}
/^Background/ {
	next
}
/^Title/	{
	next
}
/^Header/ {
	next
}
/^Title/	{

	next
}
/^XSDFile/	{
	if ($3 == PP2InvSignNRM)
	{
		exit
	}
	xsdfilename = $3 ".xsd"
	xsdfilenamefront = "http://www.3gpp.org/ftp/specs/archive/32_series/" $4 "#" $3
	xsdprefix = $2
	next
}
/^XSDTitle/	{
	mystring = $2
	for (i = 3; i < 10; i++)
	{
		if ($i != "")
		{
			mystring = mystring " " $i
		}
	}
	if (firstbackground == "YES")
	{
		title = "  " mystring
		firstbackground = "NO"
	}
	else if ($2 == "END")
	{
		title = title "\n  " xsdfilename
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" >xsdfilename
		print "<!--" >xsdfilename
		print title >xsdfilename
		print "-->" >xsdfilename
	}
	else
	{
		title = title "\n  " mystring
	}
	next
}
/^XSDNamespace/	{
	if ($2 == "END")
	{
		namestring = "<schema xmlns=\"http://www.w3.org/2001/XMLSchema\" "
		for (i = 0; i < numnamespace; i++)
		{
			namestring = namestring "xmlns:" namespace[i] "=\"" namespacename[i] "\"\n"	
		}
		namestring = namestring "xmlns:" xsdprefix "=\"" xsdfilenamefront "\"\n"	
		namestring = namestring "targetNamespace=\"" xsdfilenamefront "\" elementFormDefault=\"qualified\">"
		for (i = 0; i < numnamespace; i++)
		{
			namestring = namestring "\n<import namespace=\"" namespacename[i] "\"/>\n"
		}
		print namestring >xsdfilename
	}
	else
	{
		namespace[numnamespace] = $2
		namespacename[numnamespace] = "http://www.3gpp.org/ftp/specs/archive/32_series/" $4 "#" $3
		numnamespace = numnamespace + 1

	}
	next
}
/^IOC/ {
	next
}
/^XSDcontainment/ {
	classname = $2
	containment = $3
	if (containment != "abstract")
	{
		if (containment == "nosubstitute")
		{
			print "<element name=\"" classname "\">" >xsdfilename
		}
		else
		{
			print "<element name=\"" classname "\" substitutionGroup=\"" containment "\">" >xsdfilename
		}
		print "<complexType>" >xsdfilename
		print "<complexContent>" >xsdfilename
		print "<extension base=\"xn:NrmClass\">" >xsdfilename
		print "<sequence>" >xsdfilename
		print "<element name=\"attributes\" minOccurs=\"0\">" >xsdfilename
		print "<complexType>" >xsdfilename
		print "<all>" >xsdfilename
		abstract = "NO"
	}
	next
}
/^userLabel/	{
	next
}
/^Link /	{
	next
}
/^EE /	{
	next
}
/^XSDBackground/	{
	mystring = $2
	for (i = 3; i < 20; i++)
	{
		if ($i != "")
		{
			mystring = mystring " " $i
		}
	}
	print mystring >xsdfilename
	next
}
/^XSDcontained/	{
	if (containment == "abstract")
	{
		next
	}
	if ($2 != "END")
	{
		print "<element ref=\"" $2 "\"/>" >xsdfilename
	}
	else
	{
		print "</choice>" >xsdfilename
		print "</sequence>" >xsdfilename
		print "</extension>" >xsdfilename
		print "</complexContent>" >xsdfilename
		print "</complexType>" >xsdfilename
		print "</element>" >xsdfilename
		if (endstring == "")
		{
			endstring = "<element name=\"" classname "OptionallyContainedNrmClass\" type=\"xn:NrmClass\" abstract=\"true\"/>"
		}
		else
		{
			endstring = endstring "\n<element name=\"" classname "OptionallyContainedNrmClass\" type=\"xn:NrmClass\" abstract=\"true\"/>"
		}
	}
	next
}
/^XSD/	{
	if (containment == "abstract")
	{
		next
	}
	if ($2 != "END")
	{
		print "<element name=\"" $2 "\" type=\"" $3 "\" minOccurs=\"0\"/>" >xsdfilename
	}
	else
	{
		print "</all>" >xsdfilename
		print "</complexType>" >xsdfilename
		print "</element>" >xsdfilename
		print "<choice minOccurs=\"0\" maxOccurs=\"unbounded\">" >xsdfilename
		print "<element ref=\"" xsdprefix ":" classname "OptionallyContainedNrmClass\"/>" >xsdfilename
	}
	next
}
function printline(string)
{
	therest = ""
	if (length(string) <= 60)
	{
		printstring = string
		return
	}
	num = split(string, a, " ")
	newstring = a[1]
	for (i = 2; i <= num; i++)
	{
		if (length(newstring) + 1 + length(a[i]) <= 60)
		{
			newstring = newstring " " a[i]
		}
		else
		{
			break
		}
	}
	printstring = newstring
	therest = a[i]
	for (i = i + 1; i <= num; i++)
	{
		therest = therest " " a[i]
	}
	return
}
function uppercase(a)
{
	if (a == "a") return "A"
	if (a == "b") return "B"
	if (a == "c") return "C"
	if (a == "d") return "D"
	if (a == "e") return "E"
	if (a == "f") return "F"
	if (a == "g") return "G"
	if (a == "h") return "H"
	if (a == "i") return "I"
	if (a == "j") return "J"
	if (a == "k") return "K"
	if (a == "l") return "L"
	if (a == "m") return "M"
	if (a == "n") return "N"
	if (a == "o") return "O"
	if (a == "p") return "P"
	if (a == "q") return "Q"
	if (a == "r") return "R"
	if (a == "s") return "S"
	if (a == "t") return "T"
	if (a == "u") return "U"
	if (a == "v") return "V"
	if (a == "w") return "W"
	if (a == "x") return "X"
	if (a == "y") return "Y"
	if (a == "z") return "Z"
	return a
}
END	{
	if (endstring != "")
	{
		print endstring >xsdfilename
	}
	print "</schema>" >xsdfilename
}