BEGIN	{
	indexer = 0
}
/^Xsd/	{
	next
}
/^IOC /	{
	indexer = indexer + 1
	iocnames[indexer] = $2
	iocinh[indexer] = $3
	if ($4 == "abstract")
	{
		abstract[indexer] = "YES"
	}
	ioccontainedby[indexer] = 0
	iocattribute[indexer] = 0
	ioccontaining[indexer] = 0
	next
}
/^Containedby /	{
	containedby[indexer,ioccontainedby[indexer]] = $2
	ioccontainedby[indexer] = ioccontainedby[indexer] + 1
	next
}
/^Attribute / {
	attribute[indexer,iocattribute[indexer]] = $2
	attributetype[indexer,iocattribute[indexer]] = $4
	if ($4 == "")
	{
		print "Invalid attribute: " $0
	}
	if ($4 == "notspecified")
	{
		attributetype[indexer,iocattribute[indexer]] = "Not Specified"
	}
	iocattribute[indexer] = iocattribute[indexer] + 1
	next
}
/^Containing /	{
	mydata = $2
	if (mydata == "UserDefinedClass")
	{
		mydata = "Vendor Defined Class"
	}
	containing[indexer,ioccontaining[indexer]] = mydata
	ioccontaining[indexer] = ioccontaining[indexer] + 1
	next
}
//	{
	print "Invalid line: " $0
}
END	{
	# Add entries for VsDataContainer
	vsdata = 0
	for (i = 1; i <= indexer; i++)
	{
		if (iocnames[i] == "VsDataContainer")
		{
			vsdata = i
		}
	}
	if (vsdata == 0)
	{
		print "Can't find VsDataContainer"
	}
	for (i = 1; i < indexer; i++)
	{
		if ((iocinh[i] == "ManagedFunction") || (iocinh[i] == "Link") || (iocinh[i] == "ExternalIOC"))
		{

			containing[i,ioccontaining[i]] = "VsDataContainer"
			ioccontaining[i] = ioccontaining[i] + 1
			containedby[vsdata,ioccontainedby[vsdata]] = iocnames[i]
			ioccontainedby[vsdata] = ioccontainedby[vsdata] + 1
		}
	}
	# Add entries for SubNetwork
	vsdata = 0
	for (i = 1; i <= indexer; i++)
	{
		if (iocnames[i] == "SubNetwork")
		{
			vsdata = i
		}
	}
	if (vsdata == 0)
	{
		print "Can't find SubNetwork"
	}
	for (i = 1; i < indexer; i++)
	{
		if (abstract[i])
		{
		}
		else
		{
			gothere = "NO"
			for (j = 0; j < ioccontainedby[i]; j++)
			{
				if (containedby[i,j] == "SubNetwork")
				{
					gothere = "YES"
				}
			}
			if (gothere == "YES")
			{
				gothere = "NO"
				for (j = 0; j < ioccontaining[vsdata]; j++)
				{
					if (containing[vsdata,j] == iocnames[i])
					{
						gothere = "YES"
					}
				}
				if (gothere == "NO")
				{
					containing[vsdata,ioccontaining[vsdata]] = iocnames[i]
					ioccontaining[vsdata] = ioccontaining[vsdata] + 1
				}
			}	
		}
	}
	# Add entries for ManagedElement
	vsdata = 0
	for (i = 1; i <= indexer; i++)
	{
		if (iocnames[i] == "ManagedElement")
		{
			vsdata = i
		}
	}
	if (vsdata == 0)
	{
		print "Can't find ManagedElement"
	}
	for (i = 1; i < indexer; i++)
	{
		if (abstract[i])
		{
		}
		else
		{
			gothere = "NO"
			for (j = 0; j < ioccontainedby[i]; j++)
			{
				if (containedby[i,j] == "ManagedElement")
				{
					gothere = "YES"
				}
			}
			if (gothere == "YES")
			{
				gothere = "NO"
				for (j = 0; j < ioccontaining[vsdata]; j++)
				{
					if (containing[vsdata,j] == iocnames[i])
					{
						gothere = "YES"
					}
				}
				if (gothere == "NO")
				{
					containing[vsdata,ioccontaining[vsdata]] = iocnames[i]
					ioccontaining[vsdata] = ioccontaining[vsdata] + 1
				}
			}	
		}
	}
	# Verify ContainedBy */
	for (i = 1; i <= indexer; i++)
	{
		for (j = 0; j < ioccontainedby[i]; j++)
		{
			gothere = 0
			if (containedby[i,j] != "nothing")
			{
				for (z = 1; z <= indexer; z++)
				{
					if (containedby[i,j] == iocnames[z])
					{
						gothere = z
					}
				}
				if (gothere == 0)
				{
					print "Invalid containedby entry: " iocnames[i] " " containedby[i,j]
				}		
			}
		}
	}
	# Verify Containing */
	for (i = 1; i <= indexer; i++)
	{
		for (j = 0; j < ioccontaining[i]; j++)
		{
			gothere = "NO"
			if (containing[i,j] != "Vendor Defined Class")
			{
				for (z = 1; z <= indexer; z++)
				{
					if (containing[i,j] == iocnames[z])
					{
						gothere = "YES"
					}
				}
				if (gothere == "NO")
				{
					print "Invalid containing entry: " iocnames[i] " " containing[i,j]
				}
			}
		}
	}
	for (i = 1; i <= indexer; i++)
	{
		alreadyhave = 0
		for (j = 0; j < ioccontaining[i]; j++)
		{
			if (containing[i,j] == "VsDataContainer")
			{
				alreadyhave = alreadyhave + 1
				if (alreadyhave == 2)
				{
					ioccontaining[i] = ioccontaining[i] - 1
					break
				}
			}
		}
	}
	# Add any missing entries
	for (i = 1; i <= indexer; i++)
	{
		for (j = 0; j < ioccontaining[i]; j++)
		{
			if (containing[i,j] != "Vendor Defined Class")
			{
				for (z = 1; z <= indexer; z++)
				{
					if (containing[i,j] == iocnames[z])
					{
						break
					}
				}
				alreadyhave = 0
				for (k = 0; k < ioccontainedby[z]; k++)
				{
					if (containedby[z,k] == iocnames[i])
					{
						alreadyhave = 1
					}
				}
				if (alreadyhave == 0)
				{
					containedby[z,ioccontainedby[z]] = iocnames[i]
					ioccontainedby[z] = ioccontainedby[z] + 1
				}
			} 
		}
		for (j = 0; j < ioccontainedby[i]; j++)
		{
			if (containedby[i,j] != "nothing")
			{
				for (z = 1; z <= indexer; z++)
				{
					if (containedby[i,j] == iocnames[z])
					{
						break
					}
				}
				alreadyhave = 0
				for (k = 0; k < ioccontaining[z]; k++)
				{
					if (containing[z,k] == iocnames[i])
					{
						alreadyhave = 1
					}
				}
				if (alreadyhave == 0)
				{
					containing[z,ioccontaining[z]] = iocnames[i]
					ioccontaining[z] = ioccontaining[z] + 1
				}
			} 
		}
	}
	print "IOC%Inheritance%Contained By%Contained Under%Attributes%XSD Type"
	for (i = 1; i <= indexer; i++)
	{
		for (j = 0; j < ioccontainedby[i]; j++)
		{
			if (containedby[i,j] == "nothing")
			{
				containedby[i,j] = "zzzzz"
			}
		}
		order = "YES"
		while (order == "YES")
		{
			order = "NO"	
			for (j = 1; j < ioccontainedby[i]; j++)
			{
				if (containedby[i,j-1] > containedby[i,j])
				{
					temp = containedby[i,j]
					containedby[i,j] = containedby[i,j-1]
					containedby[i,j-1] = temp
					order = "YES"
				}
			}
		}
		for (j = 0; j < ioccontainedby[i]; j++)
		{
			if (containedby[i,j] == "zzzzz")
			{
				containedby[i,j] = "nothing"
			}
		}
	}
	for (i = 1; i <= indexer; i++)
	{
		for (j = 0; j < ioccontaining[i]; j++)
		{
			if (containing[i,j] == "Vendor Defined Class")
			{
				containing[i,j] = "zzzzz"
			}
		}
		order = "YES"
		while (order == "YES")
		{
			order = "NO"	
			for (j = 1; j < ioccontaining[i]; j++)
			{
				if (containing[i,j-1] > containing[i,j])
				{
					temp = containing[i,j]
					containing[i,j] = containing[i,j-1]
					containing[i,j-1] = temp
					order = "YES"
				}
			}
		}
		for (j = 0; j < ioccontaining[i]; j++)
		{
			if (containing[i,j] == "zzzzz")
			{
				containing[i,j] = "vendor defined IOC"
			}
		}
	}
	for (i = 1; i <= indexer; i++)
	{
		order = "YES"
		while (order == "YES")
		{
			order = "NO"	
			for (j = 1; j < iocattribute[i]; j++)
			{
				if (attribute[i,j-1] > attribute[i,j])
				{
					temp = attribute[i,j]
					attribute[i,j] = attribute[i,j-1]
					attribute[i,j-1] = temp
					temp = attributetype[i,j]
					attributetype[i,j] = attributetype[i,j-1]
					attributetype[i,j-1] = temp
					order = "YES"
				}
			}
		}
	}
	for (i = 1; i <= indexer; i++)
	{
		if (abstract[i])
		{
			print iocnames[i] "%" iocinh[i] " (abstract)"
		}
		else
		{
			print iocnames[i] "%" iocinh[i]
		}
		for (j = 0; j < ioccontainedby[i]; j++)
		{
			print iocnames[i] "%%" containedby[i,j]
		}
		for (j = 0; j < ioccontaining[i]; j++)
		{
			print iocnames[i] "%%%" containing[i,j]
		}
		for (j = 0; j < iocattribute[i]; j++)
		{
			print iocnames[i] "%%%%" attribute[i,j] "%" attributetype[i,j]
		}
	}
}
